var extractValues = require('../templates/template-utils.js').extractValues;

var assertionTypeMap = {
  '==': 'equal',
  '===': 'deepEqual',
  '!==': 'notEqual',
  '!===': 'notDeepEqual'
};

//Takes string, matches to hash map, returns the converted value
var convertAssertionType = function(type) {
  return assertionTypeMap[type];
};

var extractTestDetails = function(parsedAssertions) {
  var assertionParts;
  return parsedAssertions.map(function(assertion) {
    assertionParts = extractValues(assertion, '{assertionInput} {assertionType} {assertionOutput} ({assertionMessage})');
    try {
      assertionParts.assertionType = convertAssertionType(assertionParts.assertionType);
      if (assertionParts.assertionType === undefined) {
        throw 'assertion error';
      }
    } catch (e) {
      assertionParts = {error: 'Assertion syntax error, please fix assertion syntax.'};
    }
    return assertionParts;
  });
};

module.exports = {
  extractTestDetails: extractTestDetails
};
